<?php

  class dc_news extends data
  {

    # ----------------------------------------------------------------------------------------
    #                                                                               categories
    #

    function news_categories()
    { return $this->categories(array("root", "news"));
    }

    function all_news_categories()
    { return $this->categories(array("root", "news"), 0, null, "", true);
    }

    function news_categorie($id)
    { return $this->categorie($id);
    }

    function add_news_categorie($titre, $icone, $description)
    { return $this->add_categorie(null, $titre, $icone, $description, "", $this->id_categorie(array("root", "news")));
    }

    function set_news_categorie($id, $titre, $icone, $description)
    { return $this->set_categorie($id, null, $titre, $icone, $description);
    }

    function del_news_categorie($id, $dest)
    { if($this->move_contenus($id, $dest)) return $this->del_categorie($id);
      return false;
    }

    # ----------------------------------------------------------------------------------------
    #                                                                                 contenus
    #

    function news($path, $start = 0, $depth = 0, $public = false, $max = null)
    { return $this->contenus($path, $start, $max, $public ? " AND public=1 AND date_publication <= NOW()" : "", $depth);
    }

    function add_news($categorie, $titre, $contenu, $auteur, $date_publication, $public)
    { return $this->add_contenu(null, $categorie, $titre, "", $contenu, $auteur, $date_publication, $public);
    }

    function set_news($id, $categorie, $titre, $contenu, $auteur, $date_publication, $public)
    { return $this->set_contenu($id, null, $categorie, $titre, "", $contenu, $auteur, $date_publication, $public);
    }

    function del_news($id)
    { return $this->del_contenu($id);
    }

  }

?>